
/*  A Bison parser, made from src/parser.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	TOKEN_ID	258
#define	TOKEN_NUM	259
#define	TOKEN_COUNT	260
#define	TOKEN_STR	261
#define	TOKEN_DIRECTIVE	262
#define	TOKEN_TEXT	263
#define	TOKEN_CHR	264
#define	TOKEN_FLT	265
#define	TOKEN_REG	266
#define	TOKEN_INSN	267
#define	TOKEN_DDATA	268
#define	TOKEN_PREFIX	269
#define	TOKEN_SPECIAL	270
#define	TOKEN_EQ	271
#define	TOKEN_CMP	272
#define	TOKEN_ALLD	273
#define	TOKEN_ALLW	274
#define	TOKEN_SECTION	275
#define	TOKEN_BITS	276
#define	TOKEN_INCLUDE	277
#define	TOKEN_INCBIN	278
#define	TOKEN_ALIGN	279
#define	TOKEN_COMMON	280
#define	TOKEN_GLOBAL	281
#define	TOKEN_EXTERN	282
#define	TOKEN_DEFINE	283
#define	TOKEN_REPEAT	284
#define	TOKEN_MACRO	285
#define	TOKEN_END	286
#define	TOKEN_IF	287
#define	TOKEN_ELSE	288
#define	TOKEN_BASE	289
#define	TOKEN_HERE	290
#define	TOKEN_SHL	291
#define	TOKEN_SHR	292
#define	TOKEN_DIV	293
#define	TOKEN_MOD	294
#define	TOKEN_AND	295
#define	TOKEN_OR	296
#define	TOKEN_XOR	297
#define	TOKEN_NOT	298
#define	TOKEN_DEF	299
#define	TOKEN_PROC	300
#define	TOKEN_USES	301
#define	TOKEN_ARG	302
#define	TOKEN_LOCAL	303
#define	TOKEN_ENDP	304
#define	TOKEN_TIMES	305
#define	UNARY_MINUS	306


#include <stdarg.h>

#include "globals.h"
#include "jaslib.h"

#include "ptypes.h"
#include "lexan.h"
#include "symmngr.h"
#include "bpatch.h"

#include "assemble.h"
#include "eval.h"

#define PARAM_DELTA				8

typedef union {
	EXPR_RESULT		*result;
	OPERAND			instrOp;
	struct symbol	*identifier;
	long			intval;
	char			*strval;
	char			chrval;
	float			floatval;
	struct {
		int DeclType;
		int DeclSize;
	}				vardecl;

	struct {
		int		Lines;
		char	*text;
	}				textval;
} YYSTYPE;

/* The instruction being parsed and assembled */
static INSN instr;

/* sizes and special flags */
static long reg_flags[] = {
	0, REG8, REG_AL, REG_AX, REG8, REG8, REG16, REG16, REG8, REG_CL,
	REG_CREG, REG_CREG, REG_CREG, REG_CR4, REG_CS, REG_CX, REG8,
	REG16, REG8, REG_DREG, REG_DREG, REG_DREG, REG_DREG, REG_DREG,
	REG_DREG, REG_DESS, REG_DX, REG_EAX, REG32, REG32, REG_ECX,
	REG32, REG32, REG_DESS, REG32, REG32, REG_FSGS, REG_FSGS, REG16,
	REG16, REG_DESS, FPU0, FPUREG, FPUREG, FPUREG, FPUREG, FPUREG,
	FPUREG, FPUREG, REG_TREG, REG_TREG, REG_TREG, REG_TREG, REG_TREG
};

static struct ProcInfo {
	SYMBOL	*Id;
	int		RegList[20];
	short	RegCount;
	int		LocalSize;
	int		ParamSize;
} CurrProc;

static SYMBOL	*SecId;
static long		Segment;
static long		Offset;
static long		LocalOffset;

static short	OprsCount;
static OPERAND	*TempOp;

static short	mref;
static PATCH	*PatchPtr;
static EXTOP	**eoptail;

static long		anInt;
static float	aFloat;

static int		ParamPos;
static int		ParamSize;
static char		**ParamPtr;


/* Parser's utility functions */
static long		AssembleProcProlog(struct ProcInfo *);
static long		AssembleProcEpilog(struct ProcInfo *);
static long		IncludeBinary(char *, long, long);
static int		DefineLabel(SYMBOL *);
static OPERAND	*CalcMemRef(register EXPR_RESULT *, register EXPR_RESULT *);
static OPERAND	*ProcessOperand(EXPR_RESULT *);
static EXTOP	*ProcessExtop(int, EXPR_RESULT *);
static int		ProcessOverride(int);
static void		InstrCleanup();
static int		SymRefs(register EXPR_RESULT *, short, ...);
static int		yyerror(char *);

/* Additional token info */
int TokenInfo;
short int CodeBits;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		211
#define	YYFLAG		-32768
#define	YYNTBASE	63

#define YYTRANSLATE(x) ((unsigned)(x) <= 306 ? yytranslate[x] : 110)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    56,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    61,
    62,    53,    51,    57,    52,     2,    54,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    58,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    59,     2,    60,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    55
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     5,     7,    10,    17,    24,    34,    38,    41,
    43,    47,    48,    55,    58,    60,    61,    62,    66,    69,
    70,    71,    75,    77,    81,    82,    84,    85,    89,    93,
    95,    97,    99,   100,   102,   103,   107,   111,   115,   118,
   119,   120,   124,   126,   129,   132,   136,   139,   144,   147,
   150,   154,   161,   162,   164,   168,   170,   172,   173,   176,
   181,   182,   185,   186,   188,   190,   193,   195,   197,   198,
   202,   203,   204,   207,   209,   213,   215,   219,   222,   224,
   230,   231,   234,   235,   237,   239,   242,   243,   245,   246,
   248,   250,   254,   256,   259,   262,   266,   270,   274,   278,
   282,   286,   290,   294,   298,   302,   306,   310,   312,   314,
   316,   318,   320,   322,   324,   326,   328,   336,   344,   349,
   354,   358
};

static const short yyrhs[] = {    63,
    64,     0,    64,     0,    65,     0,    66,    56,     0,    29,
   106,    56,     8,    31,    56,     0,    32,   108,    56,     8,
    31,    56,     0,    32,   108,    56,     8,    33,    56,     8,
    31,    56,     0,    22,     6,    56,     0,     1,    56,     0,
    84,     0,    89,    90,    68,     0,     0,     3,    45,    67,
    73,    77,    70,     0,     3,    49,     0,    49,     0,     0,
     0,    12,    69,    94,     0,    13,   104,     0,     0,     0,
    48,    71,    72,     0,    80,     0,    72,    57,    80,     0,
     0,    74,     0,     0,    46,    75,    76,     0,    74,    57,
    76,     0,    11,     0,    18,     0,    19,     0,     0,    78,
     0,     0,    47,    79,    80,     0,    78,    57,    80,     0,
     3,    58,    81,     0,    15,    82,     0,     0,     0,    58,
    83,   106,     0,     7,     0,    20,     3,     0,    21,     4,
     0,    23,     6,    88,     0,    24,   106,     0,    25,     3,
    58,    81,     0,    26,     3,     0,    27,     3,     0,    28,
     3,     6,     0,    30,     3,    85,    56,     8,    31,     0,
     0,    86,     0,    86,    57,    87,     0,    87,     0,     6,
     0,     0,    57,     4,     0,    57,     4,    57,     4,     0,
     0,     3,    58,     0,     0,    91,     0,    92,     0,    91,
    92,     0,    11,     0,    14,     0,     0,    50,    93,   106,
     0,     0,     0,    95,    96,     0,    97,     0,    96,    57,
    97,     0,    98,     0,    98,    58,    98,     0,   101,    99,
     0,   106,     0,    59,   103,   106,   100,    60,     0,     0,
    58,   106,     0,     0,   102,     0,    15,     0,   102,    15,
     0,     0,    15,     0,     0,   105,     0,   106,     0,   105,
    57,   106,     0,   107,     0,    52,   106,     0,    43,   106,
     0,    61,   106,    62,     0,   106,    51,   106,     0,   106,
    52,   106,     0,   106,    38,   106,     0,   106,    39,   106,
     0,   106,    53,   106,     0,   106,    54,   106,     0,   106,
    37,   106,     0,   106,    36,   106,     0,   106,    40,   106,
     0,   106,    41,   106,     0,   106,    42,   106,     0,     3,
     0,    11,     0,     4,     0,    10,     0,     6,     0,     9,
     0,    35,     0,    34,     0,   109,     0,    61,   108,    62,
    40,    61,   108,    62,     0,    61,   108,    62,    41,    61,
   108,    62,     0,    43,    61,   108,    62,     0,    44,    61,
     3,    62,     0,   106,    16,   106,     0,   106,    17,   106,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   238,   239,   242,   256,   258,   272,   282,   295,   298,   305,
   307,   313,   331,   343,   356,   371,   372,   378,   426,   441,
   442,   448,   453,   459,   466,   467,   470,   472,   475,   488,
   489,   493,   499,   500,   503,   509,   513,   520,   536,   582,
   583,   584,   600,   606,   647,   658,   661,   679,   699,   726,
   743,   760,   783,   784,   790,   791,   794,   807,   808,   809,
   813,   814,   829,   830,   833,   834,   837,   852,   862,   863,
   877,   882,   890,   900,   901,   904,   914,   930,   937,   947,
   961,   962,   965,   966,   969,   975,   983,   984,  1004,  1005,
  1008,  1016,  1028,  1029,  1030,  1043,  1044,  1045,  1046,  1074,
  1103,  1161,  1202,  1225,  1248,  1271,  1294,  1318,  1352,  1353,
  1354,  1355,  1356,  1357,  1358,  1363,  1365,  1367,  1369,  1373,
  1382,  1413
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","TOKEN_ID",
"TOKEN_NUM","TOKEN_COUNT","TOKEN_STR","TOKEN_DIRECTIVE","TOKEN_TEXT","TOKEN_CHR",
"TOKEN_FLT","TOKEN_REG","TOKEN_INSN","TOKEN_DDATA","TOKEN_PREFIX","TOKEN_SPECIAL",
"TOKEN_EQ","TOKEN_CMP","TOKEN_ALLD","TOKEN_ALLW","TOKEN_SECTION","TOKEN_BITS",
"TOKEN_INCLUDE","TOKEN_INCBIN","TOKEN_ALIGN","TOKEN_COMMON","TOKEN_GLOBAL","TOKEN_EXTERN",
"TOKEN_DEFINE","TOKEN_REPEAT","TOKEN_MACRO","TOKEN_END","TOKEN_IF","TOKEN_ELSE",
"TOKEN_BASE","TOKEN_HERE","TOKEN_SHL","TOKEN_SHR","TOKEN_DIV","TOKEN_MOD","TOKEN_AND",
"TOKEN_OR","TOKEN_XOR","TOKEN_NOT","TOKEN_DEF","TOKEN_PROC","TOKEN_USES","TOKEN_ARG",
"TOKEN_LOCAL","TOKEN_ENDP","TOKEN_TIMES","'+'","'-'","'*'","'/'","UNARY_MINUS",
"'\\n'","','","':'","'['","']'","'('","')'","lines","line","aline","dummy","@1",
"assembler_instr","@2","locals","@3","localvar","uses","registers","@4","register",
"parameters","paramdecl","@5","localdecl","typespec","count","@6","directive",
"macro_param_def","macro_params","macro_param","incbin_param","label","prefixes",
"prefs","prefix","@7","operands","@8","operandlist","operand","operand_spec",
"imm_or_mem","part_2","sizovr","size_overrides","addr_override","data_list",
"datas","expr","expr0","bexpr","bexpr0", NULL
};
#endif

static const short yyr1[] = {     0,
    63,    63,    64,    65,    65,    65,    65,    65,    65,    66,
    66,    67,    66,    66,    66,    68,    69,    68,    68,    70,
    71,    70,    72,    72,    73,    73,    75,    74,    74,    76,
    76,    76,    77,    77,    79,    78,    78,    80,    81,    82,
    83,    82,    84,    84,    84,    84,    84,    84,    84,    84,
    84,    84,    85,    85,    86,    86,    87,    88,    88,    88,
    89,    89,    90,    90,    91,    91,    92,    92,    93,    92,
    94,    95,    94,    96,    96,    97,    97,    98,    99,    99,
   100,   100,   101,   101,   102,   102,   103,   103,   104,   104,
   105,   105,   106,   106,   106,   106,   106,   106,   106,   106,
   106,   106,   106,   106,   106,   106,   106,   107,   107,   107,
   107,   107,   107,   107,   107,   108,   108,   108,   108,   109,
   109,   109
};

static const short yyr2[] = {     0,
     2,     1,     1,     2,     6,     6,     9,     3,     2,     1,
     3,     0,     6,     2,     1,     0,     0,     3,     2,     0,
     0,     3,     1,     3,     0,     1,     0,     3,     3,     1,
     1,     1,     0,     1,     0,     3,     3,     3,     2,     0,
     0,     3,     1,     2,     2,     3,     2,     4,     2,     2,
     3,     6,     0,     1,     3,     1,     1,     0,     2,     4,
     0,     2,     0,     1,     1,     2,     1,     1,     0,     3,
     0,     0,     2,     1,     3,     1,     3,     2,     1,     5,
     0,     2,     0,     1,     1,     2,     0,     1,     0,     1,
     1,     3,     1,     2,     2,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     7,     7,     4,     4,
     3,     3
};

static const short yydefact[] = {     0,
     0,     0,    43,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    15,     0,     2,     3,     0,
    10,    63,     9,    12,    14,    62,    44,    45,     0,    58,
   108,   110,   112,   113,   111,   109,   115,   114,     0,     0,
     0,    47,    93,     0,    49,    50,     0,     0,    53,     0,
     0,     0,     0,     0,   116,     1,     4,    67,    68,    69,
    16,    64,    65,    25,     8,     0,    46,    95,    94,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    51,     0,    57,     0,    54,    56,     0,     0,
     0,     0,     0,     0,     0,     0,    17,    89,    11,    66,
    27,    33,    26,    59,    96,   104,   103,    99,   100,   105,
   106,   107,    97,    98,   101,   102,    40,    48,     0,     0,
     0,     0,     0,     0,   121,   122,     0,    70,    72,    19,
    90,    91,     0,    35,    20,    34,     0,     0,    41,    39,
     0,     0,    55,   119,   120,     0,     0,     0,     0,    18,
    83,     0,    30,    31,    32,    28,     0,    21,    13,     0,
    29,    60,     0,     5,    52,     0,     0,     6,     0,    85,
    73,    74,    76,     0,    84,    92,     0,    36,     0,    37,
    42,     0,     0,     0,    83,    83,    87,    78,    79,    86,
     0,    22,    23,   117,   118,     0,    75,    77,    88,     0,
    38,     0,     7,    81,    24,     0,     0,    82,    80,     0,
     0
};

static const short yydefgoto[] = {    17,
    18,    19,    20,    64,    99,   129,   159,   179,   192,   102,
   103,   133,   156,   135,   136,   157,   178,   118,   140,   163,
    21,    86,    87,    88,    67,    22,    61,    62,    63,    96,
   150,   151,   171,   172,   173,   188,   207,   174,   175,   200,
   130,   131,    53,    43,    54,    55
};

static const short yypact[] = {   223,
   -39,   -43,-32768,    16,    33,    34,    35,   108,    45,    46,
    47,    50,   108,    52,    48,-32768,   183,-32768,-32768,     0,
-32768,    -7,-32768,-32768,-32768,-32768,-32768,-32768,     4,    21,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   108,   108,
   108,   288,-32768,    22,-32768,-32768,    73,   281,    78,   128,
    26,    48,   251,    37,-32768,-32768,-32768,-32768,-32768,-32768,
    15,    -7,-32768,    43,-32768,    90,-32768,-32768,-32768,   -28,
   108,   108,   108,   108,   108,   108,   108,   108,   108,   108,
   108,    80,-32768,   102,-32768,    42,    44,-32768,    48,   110,
   224,    62,   108,   108,   117,   108,-32768,   108,-32768,-32768,
-32768,    79,    72,    76,-32768,    23,    23,-32768,-32768,    69,
   313,   307,   -18,   -18,-32768,-32768,    77,-32768,    99,   132,
    78,    84,    85,   -11,   288,   288,   -15,   288,    92,-32768,
    96,   288,    28,-32768,   101,   100,    28,   137,-32768,-32768,
    94,   125,-32768,-32768,-32768,    97,    98,   105,   109,-32768,
   149,   108,-32768,-32768,-32768,-32768,   164,-32768,-32768,   164,
-32768,-32768,   108,-32768,-32768,    48,    48,-32768,   160,-32768,
   113,-32768,   114,    93,   158,   288,   116,-32768,   164,-32768,
   288,   115,   119,   144,   149,   149,   161,-32768,   288,-32768,
    80,   121,-32768,-32768,-32768,   123,-32768,-32768,-32768,   108,
-32768,   164,-32768,   258,-32768,   108,   122,   288,-32768,   185,
-32768
};

static const short yypgoto[] = {-32768,
   170,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    51,-32768,-32768,-32768,  -157,     2,-32768,-32768,
-32768,-32768,-32768,    70,-32768,-32768,-32768,-32768,   138,-32768,
-32768,-32768,-32768,    14,    30,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    -8,-32768,   -51,-32768
};


#define	YYLAST		367


static const short yytable[] = {    42,
    92,    24,   180,    58,    48,    25,    59,    71,    72,    73,
    74,    75,    76,    77,    26,   148,    23,   149,    27,    73,
    74,   193,    78,    79,    80,    81,    97,    98,   146,   147,
    68,    69,    70,   105,    80,    81,    28,   122,   153,    29,
    30,    68,    60,    91,   205,   154,   155,    44,    45,    46,
    31,    32,    47,    33,    49,    57,    34,    35,    36,    65,
    73,    74,   106,   107,   108,   109,   110,   111,   112,   113,
   114,   115,   116,    78,    79,    80,    81,    66,    83,    82,
    91,    37,    38,    85,   125,   126,    90,   128,   101,   132,
    50,    51,    95,   104,   117,    31,    32,   120,    33,    40,
   121,    34,    35,    36,    71,    72,    73,    74,    52,   119,
    31,    32,   123,    33,   182,   183,    34,    35,    36,    78,
    79,    80,    81,   124,   127,   134,    37,    38,   137,   141,
    31,    32,   138,    33,   139,    39,    34,    35,    36,   142,
   162,    37,    38,   176,    40,   144,   145,   -71,   158,   164,
    39,   187,   152,    41,   181,   165,   160,   166,   167,    40,
   168,    37,    38,   170,   169,   189,   177,   184,    41,   185,
    39,   186,   190,   191,   196,   199,   194,   202,   203,    40,
   195,   209,   210,     1,   211,     2,    56,   161,    89,     3,
   143,   204,   201,   -61,   -61,   -61,   -61,   208,   197,   100,
     0,     0,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,     0,    15,   198,     0,     0,     0,     0,
     0,     0,     0,     1,     0,     2,     0,     0,     0,     3,
     0,    16,   -61,   -61,   -61,   -61,   -61,     0,   -61,    93,
    94,     0,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,     0,    15,     0,     0,     0,     0,    71,
    72,    73,    74,    75,    76,    77,    93,    94,     0,     0,
     0,    16,   -61,     0,    78,    79,    80,    81,   -61,     0,
     0,     0,     0,     0,     0,   105,    71,    72,    73,    74,
    75,    76,    77,    71,    72,    73,    74,    75,    76,    77,
     0,    78,    79,    80,    81,     0,     0,     0,    78,    79,
    80,    81,     0,     0,     0,   206,    71,    72,    73,    74,
    75,    76,    77,    71,    72,    73,    74,    75,    76,    77,
     0,    78,    79,    80,    81,     0,    84,     0,    78,    79,
    80,    81,    71,    72,    73,    74,    75,    76,    71,    72,
    73,    74,    75,     0,     0,     0,     0,    78,    79,    80,
    81,     0,     0,    78,    79,    80,    81
};

static const short yycheck[] = {     8,
    52,    45,   160,    11,    13,    49,    14,    36,    37,    38,
    39,    40,    41,    42,    58,    31,    56,    33,     3,    38,
    39,   179,    51,    52,    53,    54,    12,    13,    40,    41,
    39,    40,    41,    62,    53,    54,     4,    89,    11,     6,
     6,    50,    50,    52,   202,    18,    19,     3,     3,     3,
     3,     4,     3,     6,     3,    56,     9,    10,    11,    56,
    38,    39,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    51,    52,    53,    54,    57,     6,    58,
    89,    34,    35,     6,    93,    94,    61,    96,    46,    98,
    43,    44,    56,     4,    15,     3,     4,    56,     6,    52,
    57,     9,    10,    11,    36,    37,    38,    39,    61,     8,
     3,     4,     3,     6,   166,   167,     9,    10,    11,    51,
    52,    53,    54,    62,     8,    47,    34,    35,    57,    31,
     3,     4,    57,     6,    58,    43,     9,    10,    11,     8,
     4,    34,    35,   152,    52,    62,    62,    56,    48,    56,
    43,    59,    57,    61,   163,    31,    57,    61,    61,    52,
    56,    34,    35,    15,    56,   174,     3,     8,    61,    57,
    43,    58,    15,    58,    31,    15,    62,    57,    56,    52,
    62,    60,     0,     1,     0,     3,    17,   137,    61,     7,
   121,   200,   191,    11,    12,    13,    14,   206,   185,    62,
    -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    -1,    32,   186,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,     1,    -1,     3,    -1,    -1,    -1,     7,
    -1,    49,    50,    11,    12,    13,    14,    -1,    56,    16,
    17,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,    36,
    37,    38,    39,    40,    41,    42,    16,    17,    -1,    -1,
    -1,    49,    50,    -1,    51,    52,    53,    54,    56,    -1,
    -1,    -1,    -1,    -1,    -1,    62,    36,    37,    38,    39,
    40,    41,    42,    36,    37,    38,    39,    40,    41,    42,
    -1,    51,    52,    53,    54,    -1,    -1,    -1,    51,    52,
    53,    54,    -1,    -1,    -1,    58,    36,    37,    38,    39,
    40,    41,    42,    36,    37,    38,    39,    40,    41,    42,
    -1,    51,    52,    53,    54,    -1,    56,    -1,    51,    52,
    53,    54,    36,    37,    38,    39,    40,    41,    36,    37,
    38,    39,    40,    -1,    -1,    -1,    -1,    51,    52,    53,
    54,    -1,    -1,    51,    52,    53,    54
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */


/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
{
			yylineno++;
			SetExpr(0);
			EvaluatorReset();
		;
    break;}
case 5:
{
			SetCritical(-1);
			if ( IsSimple(yyvsp[-4].result) != INTEGER ) {
				error(ERR_NONFATAL, INTERR);
				YYERROR;
			};
			yylineno++;
			RepeatText(yyvsp[-2].textval.text, yyvsp[-2].textval.Lines, IntVal(yyvsp[-4].result));
			/* The text stored has been copied in the new scanning
			   buffer, then we can free it up. */
			LIB_free(yyvsp[-2].textval.text);
		;
    break;}
case 6:
{
			yylineno++;
			if ( yyvsp[-4].intval ) {
				RepeatText(yyvsp[-2].textval.text, yyvsp[-2].textval.Lines, 1);
			};

			LIB_free(yyvsp[-2].textval.text);
		;
    break;}
case 7:
{
			yylineno += 2;
			if ( yyvsp[-7].intval != FALSE ) {
				RepeatText(yyvsp[-5].textval.text, yyvsp[-5].textval.Lines, 1);
			} else {
				RepeatText(yyvsp[-2].textval.text, yyvsp[-2].textval.Lines, 1);
			};

			LIB_free(yyvsp[-5].textval.text);
			LIB_free(yyvsp[-2].textval.text);
		;
    break;}
case 8:
{   SwitchToFile(yyvsp[-1].strval);   ;
    break;}
case 9:
{
			InstrCleanup();
			yyerrok;
		;
    break;}
case 10:
{;
    break;}
case 11:
{
		    /* Clear the instr struct for the next instruction */
			if ( instr.opcode != -1 ) InstrCleanup();
		;
    break;}
case 12:
{
			if ( CurrProc.Id ) {
				error(ERR_NONFATAL, GENERR,
					"Nested procedures not implemented yet!");
				FreeSymbol(yyvsp[-1].identifier);
				YYERROR;
			};

			if ( yyvsp[-1].identifier->Type != NO_TYPE && IDType(yyvsp[-1].identifier) != LABEL ) {
				error(ERR_NONFATAL, LBLERR, yyvsp[-1].identifier->Name);
				YYERROR;
			};

			/* This is used to link the local symbols (parameters
			   and variables) to the defined procedure. */
			CurrProc.Id= yyvsp[-1].identifier;
		;
    break;}
case 13:
{
			/* Define the label for the procedure */
			if ( DefineLabel(yyvsp[-5].identifier) ) YYERROR;

			/* Fill in the 'CurrProc' struct. */
			CurrProc.ParamSize= yyvsp[-1].intval;
			CurrProc.LocalSize= yyvsp[0].intval;

			Offset += AssembleProcProlog(&CurrProc);
		;
    break;}
case 14:
{
			FreeSymbolList(yyvsp[-1].identifier);

			if ( yyvsp[-1].identifier != CurrProc.Id ) {
				error(ERR_NONFATAL, UNDERR, yyvsp[-1].identifier->Name);
				FreeSymbol(yyvsp[-1].identifier);
			};

			/* Clear the procedure info struct. */
			bzero(&CurrProc, sizeof(struct ProcInfo));
		;
    break;}
case 15:
{
			if ( CurrProc.Id == NULL ) {
				error(ERR_NONFATAL, NOPROCERR);
			} else {
				/* Undefine all symbols linked to the last defined
				   procedure. */
				FreeSymbolList( CurrProc.Id );

			    /* Clear the procedure info struct. */
			    bzero(&CurrProc, sizeof(struct ProcInfo));
			};
		;
    break;}
case 16:
{ instr.opcode = -1; ;
    break;}
case 17:
{
			instr.opcode	= yyvsp[0].intval;
			instr.condition = TokenInfo;
		;
    break;}
case 18:
{
			switch ( yyvsp[-2].intval ) {
				case I_RESW:
					instr.opcode= I_RESB;
					instr.oprs[0].offset *= 2;
					break;

				case I_RESD:
					instr.opcode= I_RESB;
					instr.oprs[0].offset *= 4;
					break;

				case I_RESQ:
					instr.opcode= I_RESB;
					instr.oprs[0].offset *= 2;
					break;

				case I_REST:
					instr.opcode= I_RESB;
					instr.oprs[0].offset *= 10;
					break;

				case I_RET:
				case I_RETF:
				case I_RETN:
				case I_IRETW:
				case I_IRETD:
				case I_IRET:
					/* This is a return instruction assemble code
					   for the procedure epilog */
					Offset += AssembleProcEpilog( &CurrProc );
			};

			/* Fill in the 'patch_instr' field of the patch.
			   We must do it here because the all parsing for
			   the istruction is done and the 'instr' struct is
			   filled properly. */
			if ( PatchPtr ) {
				PatchPtr->patch_instr= instr;
				/* Calculate the size of the istruction and
				   pad the code with NOP operations */
				Offset += pad(Segment, Offset, '\x90',
				    instrsize(Segment, Offset, CodeBits, &instr));
			} else {
				Offset += assemble(Segment, Offset, CodeBits, &instr);
			}
		;
    break;}
case 19:
{
			/* Fill in some instr field */
			instr.opcode	= yyvsp[-1].intval;
			instr.condition = -1;

			if ( instr.nprefix ) {
				instr.nprefix = 0;
				error(ERR_WARNING, GENERR, "Prefixes ignored");
			};

			Offset += assemble(Segment, Offset, CodeBits, &instr);
		;
    break;}
case 20:
{ yyval.intval= 0; ;
    break;}
case 21:
{
			LocalOffset= ( CodeBits == 16 ? -2 : -4 );
			EvaluatorReset();
		;
    break;}
case 22:
{
			yyval.intval = yyvsp[0].intval;
		;
    break;}
case 23:
{
			LocalOffset -= yyvsp[0].intval;
			yyval.intval = yyvsp[0].intval;
		;
    break;}
case 24:
{
			LocalOffset -= yyvsp[0].intval;
			yyval.intval = yyvsp[-2].intval + yyvsp[0].intval;
		;
    break;}
case 27:
{ CurrProc.RegCount = 0 ;
    break;}
case 28:
{
			CurrProc.RegList[CurrProc.RegCount++]= yyvsp[0].intval;
		;
    break;}
case 29:
{
			if ( CurrProc.RegCount == elements(CurrProc.RegList) ) {
			    /* Don't save last register */
				error(ERR_WARNING, GENERR,
					"Register not saved, too much registers "
					"(try USES ALL).");
			} else {
			    CurrProc.RegList[CurrProc.RegCount++]= yyvsp[0].intval;
			};
		;
    break;}
case 30:
{ yyval.intval = yyvsp[0].intval; ;
    break;}
case 31:
{	/* Uses all long registers */
			yyval.intval = REG_ENUM_LIMIT;
		;
    break;}
case 32:
{	/* Uses all word registers */
			yyval.intval = REG_ENUM_LIMIT + 1;
		;
    break;}
case 33:
{ yyval.intval=  0; ;
    break;}
case 34:
{ yyval.intval= yyvsp[0].intval; ;
    break;}
case 35:
{
			LocalOffset= ( CodeBits == 16 ? 4 : 8 );
			EvaluatorReset();
		;
    break;}
case 36:
{
			LocalOffset += yyvsp[0].intval;
			yyval.intval = yyvsp[0].intval;
		;
    break;}
case 37:
{
			LocalOffset += yyvsp[0].intval;
			yyval.intval = yyvsp[-2].intval + yyvsp[0].intval;
		;
    break;}
case 38:
{
			if ( yyvsp[-2].identifier->Type != NO_TYPE ) {
				error(ERR_NONFATAL, LBLERR, yyvsp[-2].identifier->Name);
				yyval.intval = 0;
			} else {
				LinkSymbol(CurrProc.Id, yyvsp[-2].identifier);
				yyvsp[-2].identifier->Type = (LABEL | LOCAL) | yyvsp[0].vardecl.DeclType;
				yyvsp[-2].identifier->Value= LocalOffset;
				yyval.intval= yyvsp[0].vardecl.DeclSize;
			};

			EvaluatorReset();
		;
    break;}
case 39:
{
			switch ( yyvsp[-1].intval ) {
				case S_WORD:
					yyval.vardecl.DeclType = BITS16;
					yyval.vardecl.DeclSize = 2;
					break;

				case S_DWORD:
					yyval.vardecl.DeclType = BITS32;
					yyval.vardecl.DeclSize = 4;
					break;

				case S_QWORD:
					yyval.vardecl.DeclType = BITS64;
					yyval.vardecl.DeclSize = 8;
					break;

				case S_TWORD:
					yyval.vardecl.DeclType = BITS80;
					yyval.vardecl.DeclSize = 10;
					break;

				case S_FAR:
					yyval.vardecl.DeclType = FAR;
					yyval.vardecl.DeclSize = ( CodeBits == 16 ? 4 : 6);
					break;

				case S_NEAR:
					yyval.vardecl.DeclType = NEAR;
					yyval.vardecl.DeclSize = ( CodeBits == 16 ? 2 : 4);
					break;

				default:
					error(ERR_NONFATAL, SIZERR);

				case S_BYTE:
					yyval.vardecl.DeclType = BITS8;
					yyval.vardecl.DeclSize = 1;
			};

			yyval.vardecl.DeclSize *= yyvsp[0].intval;
		;
    break;}
case 40:
{ yyval.intval = 1; ;
    break;}
case 41:
{ SetExpr(-1); ;
    break;}
case 42:
{
			SetCritical(-1);
			if ( IsSimple(yyvsp[0].result) != INTEGER ) {
				error(ERR_NONFATAL, INTERR);
				yyval.intval = 1;
			} else {
			    yyval.intval= yyvsp[0].result->int_result;
			};

			SetCritical(0);
			SetExpr(0);
		;
    break;}
case 43:
{
			/* Handle format specific directive */
			if ( Directive(yyvsp[0].strval) ) YYERROR;
		;
    break;}
case 44:
{
			anInt= Section(yyvsp[0].identifier->Name);

			if ( anInt == NO_SEG ) {
			/* Section name is not valid */
				error(ERR_NONFATAL, INVSECERR, yyvsp[0].identifier);
				YYERROR;
			};

			/* Define some identifier fields if not defined */
			if ( yyvsp[0].identifier->Type == NO_TYPE ||
				(yyvsp[0].identifier->Type == (SECLBL | LABEL) && yyvsp[0].identifier->Value == -1) ) {
				yyvsp[0].identifier->Type   = LABEL | SECLBL;
				yyvsp[0].identifier->segment= anInt;
				yyvsp[0].identifier->offset = Offset;
				yyvsp[0].identifier->Value  = 0;

				/* Do the backpatch */
				BPatch(yyvsp[0].identifier);
			} else if ( yyvsp[0].identifier->Type != (LABEL | SECLBL) ) {
				error(ERR_NONFATAL, LBLERR, yyvsp[0].identifier->Name);
				YYERROR;
			};

			/* Save the offset reached in the current section */
			SecId->Value= Offset;

			/* Destroy all the local symbol defined in the
			   current section */
			FreeSymbolList(SecId);

			/* An now change the section ...
			   Restore the old offset and switch to the
			   segment of the new section */
			Offset = yyvsp[0].identifier->Value;
			Segment= anInt;

			SecId= yyvsp[0].identifier;
		;
    break;}
case 45:
{
			CodeBits= yyvsp[0].intval;

			if ( CodeBits != 16 && CodeBits != 32 ) {
				error(ERR_WARNING, GENERR,
					"Defaulting to 16 bits assembling");
				CodeBits = 16;
			};
		;
    break;}
case 46:
{ Offset += IncludeBinary(yyvsp[-1].strval, yyvsp[0].intval, anInt); ;
    break;}
case 47:
{
			SetCritical(-1);
			if ( IsSimple(yyvsp[0].result) != INTEGER ) {
				error(ERR_NONFATAL, INTERR);
				YYERROR;
			};

			if ( (anInt= IntVal(yyvsp[0].result)) ) {
				if ( (Offset % anInt) ) {
					Offset +=
						pad(Segment, Offset, '\x90', anInt - (Offset % anInt));
				};
			};

			EvaluatorReset();
		;
    break;}
case 48:
{
			if ( yyvsp[-2].identifier->Type != NO_TYPE ) {
				error(ERR_NONFATAL, LBLERR, yyvsp[-2].identifier->Name);
				YYERROR;
			};

			/* Defines the symbol's fields. */
			yyvsp[-2].identifier->Type   = (LABEL | COMMLBL) | yyvsp[0].vardecl.DeclType;
			yyvsp[-2].identifier->offset = 0;
			yyvsp[-2].identifier->segment= seg_alloc();
			yyvsp[-2].identifier->Value  = yyvsp[0].vardecl.DeclSize;

			/* Defines the symbol in the output format */
			Symdef(yyvsp[-2].identifier, 2);

			/* Symbol backpatch. */
			BPatch(yyvsp[-2].identifier);
		;
    break;}
case 49:
{
			if ( yyvsp[0].identifier->Type == NO_TYPE ||
				 ( IDType(yyvsp[0].identifier) == LABEL && IDFlag(yyvsp[0].identifier) == GLBLBL) ) {
			/* Defines the symbol's fields. */

				if ( yyvsp[0].identifier->Type == NO_TYPE ) {
				/* The symbol has not been defined yet, so
				   declare it as a global symbol */
					yyvsp[0].identifier->Type   = LABEL | GLBLBL;
					yyvsp[0].identifier->offset = 0;
					yyvsp[0].identifier->segment= UNDEF_SEG;
					yyvsp[0].identifier->Value  = 0;
				} else {
				/* The symbol has been defined by the assembled
				   source file, define it in the output
				   format */
					yyvsp[0].identifier->Type   = LABEL | GLBLBL;
					Symdef(yyvsp[0].identifier, 1);
				}
			} else {
				error(ERR_NONFATAL, LBLERR, yyvsp[0].identifier->Name);
				YYERROR;
			};

		;
    break;}
case 50:
{
			if ( yyvsp[0].identifier->Type != NO_TYPE ) {
				error(ERR_NONFATAL, LBLERR, yyvsp[0].identifier->Name);
				YYERROR;
			};

			/* Defines the symbol's fields. */
			yyvsp[0].identifier->Type   = LABEL | EXTLBL;
			yyvsp[0].identifier->offset = 0;
			yyvsp[0].identifier->segment= seg_alloc();
			yyvsp[0].identifier->Value  = 0;

			/* --- Define the symbol in the output format */
			Symdef(yyvsp[0].identifier, 2);
		;
    break;}
case 51:
{
			if ( yyvsp[-1].identifier->Type != NO_TYPE ) {
				error(ERR_NONFATAL, LBLERR, yyvsp[-1].identifier->Name);
				YYERROR;
			};

			/* Defines the symbol's fields. */
			yyvsp[-1].identifier->Type     = MACRO | DEFINED;
			yyvsp[-1].identifier->offset   = -1;
			yyvsp[-1].identifier->segment  = -1;
			yyvsp[-1].identifier->Value    = 0;
			yyvsp[-1].identifier->ExtraLong= 0;

			BuildMacro(yyvsp[-1].identifier, NULL, yyvsp[0].strval, 0);
		;
    break;}
case 52:
{
			if ( yyvsp[-4].identifier->Type != NO_TYPE ) {
				error(ERR_NONFATAL, LBLERR, yyvsp[-4].identifier->Name);
				YYERROR;
			};

			/* Defines the symbol's fields. */
			yyvsp[-4].identifier->Type     = MACRO;
			yyvsp[-4].identifier->offset   = -1;
			yyvsp[-4].identifier->segment  = -1;
			yyvsp[-4].identifier->Value    = 0;
			yyvsp[-4].identifier->ExtraLong= ParamPos;

			/* Build up the macro. */
			BuildMacro(yyvsp[-4].identifier, ParamPtr, yyvsp[-1].textval.text, yyvsp[-1].textval.Lines);
			ParamPtr = NULL;
			ParamPos = 0;
			ParamSize= 0;
		;
    break;}
case 53:
{ ParamPtr = NULL; ParamPos= 0; ;
    break;}
case 54:
{
			ParamPtr[ParamPos]= NULL;
		;
    break;}
case 57:
{
			if ( ParamPos == ParamSize ) {
			/* Allocates space for the parameters array. */
				ParamSize += PARAM_DELTA;
				ParamPtr= (char **)LIB_realloc(ParamPtr,
					sizeof(char *) * (ParamSize + 1));
			};

			ParamPtr[ParamPos++]= yyvsp[0].strval;
		;
    break;}
case 58:
{ yyval.intval = -1; anInt= 0; ;
    break;}
case 59:
{ yyval.intval = yyvsp[0].intval; anInt= 0; ;
    break;}
case 60:
{ yyval.intval= yyvsp[-2].intval; anInt= yyvsp[0].intval; ;
    break;}
case 61:
{ yyval.identifier = NULL; ;
    break;}
case 62:
{
			/* See if the label has been already defined */
			if ( yyvsp[-1].identifier->Type != NO_TYPE && IDType(yyvsp[-1].identifier) != LABEL ) {
				error(ERR_NONFATAL, LBLERR, yyvsp[-1].identifier->Name);
				YYERROR;
			};

			if ( DefineLabel(yyvsp[-1].identifier) ) YYERROR;
			yyval.identifier= yyvsp[-1].identifier;
		;
    break;}
case 63:
{ instr.nprefix = 0; ;
    break;}
case 67:
{
			if ( instr.nprefix == 3 ) {
				error(ERR_FATAL, PREFSERR);
				YYERROR;
			};

			if ( REG_SREG & ~reg_flags[yyvsp[0].intval] ) {
				error(ERR_FATAL, SEGERR);
				YYERROR;
			};

			instr.prefixes[instr.nprefix++]= yyvsp[0].intval;
		;
    break;}
case 68:
{
			if ( instr.nprefix == 3 ) {
				error( ERR_FATAL, PREFSERR);
				YYERROR;
			};

			instr.prefixes[instr.nprefix++]= yyvsp[0].intval;
		;
    break;}
case 69:
{ SetExpr(-1); ;
    break;}
case 70:
{
			SetCritical(-1);
			SetExpr(0);
			if ( IsSimple(yyvsp[0].result) != INTEGER ) {
				error(ERR_NONFATAL, INTERR);
				YYERROR;
			};
			instr.times = IntVal(yyvsp[0].result);
			EvaluatorReset();
		;
    break;}
case 71:
{
			instr.operands = 0;
			bzero(&instr.oprs, 3*sizeof(OPERAND));
		;
    break;}
case 72:
{
			    if ( yyvsp[0].intval >= I_RESB && yyvsp[0].intval <= I_RESW ) {
			    /* Set the critical flag if we are parsing operands for
			       a RES? istruction. */
				    SetCritical(-1);
			    };
		    ;
    break;}
case 73:
{
				instr.operands = OprsCount;
				/* Clear remaining operands */
				while ( OprsCount < 3 ) {
					instr.oprs[OprsCount].type = 0;
					OprsCount++;
				};
			;
    break;}
case 76:
{
		    if ( OprsCount == 3 ) {
			    error(ERR_NONFATAL, OPRSERR);
			    YYERROR;
		    };
			instr.oprs[OprsCount] = yyvsp[0].instrOp;
			OprsCount++;
		;
    break;}
case 77:
{
			if ( OprsCount > 1 ) {
				error(ERR_NONFATAL, OPRSERR);
				YYERROR;
			};

			instr.oprs[OprsCount]	 = yyvsp[-2].instrOp;
			instr.oprs[OprsCount + 1]= yyvsp[0].instrOp;
			instr.oprs[OprsCount].type |= COLON;

			OprsCount += 2;
		;
    break;}
case 78:
{
			yyval.instrOp = yyvsp[0].instrOp;
			yyval.instrOp.type |= yyvsp[-1].intval;
		;
    break;}
case 79:
{
			TempOp = ProcessOperand( yyvsp[0].result );
			if ( !TempOp ) {
			/* Error during operand conversion */
				YYERROR;
			};
			yyval.instrOp = *TempOp;
		;
    break;}
case 80:
{
			TempOp = ( yyvsp[-1].result ? CalcMemRef(yyvsp[-2].result, yyvsp[-1].result) : CalcMemRef(NULL, yyvsp[-2].result) );

			if ( !TempOp ) {
			/* Error during operand conversion */
				YYERROR;
			};

			yyval.instrOp = *TempOp;
			yyval.instrOp.addr_size = yyvsp[-3].intval;
		;
    break;}
case 81:
{ yyval.result = NULL; ;
    break;}
case 82:
{ yyval.result = yyvsp[0].result; ;
    break;}
case 83:
{ yyval.intval = 0; ;
    break;}
case 84:
{ yyval.intval = yyvsp[0].intval; ;
    break;}
case 85:
{
			if ( (yyval.intval = ProcessOverride(yyvsp[0].intval)) == -1 ) {
				YYERROR;
			};
		;
    break;}
case 86:
{
			if ( (yyval.intval = yyvsp[-1].intval | ProcessOverride(yyvsp[0].intval)) == -1 ) {
				YYERROR;
			};
		;
    break;}
case 87:
{ yyval.intval = 0; ;
    break;}
case 88:
{
			switch ( yyvsp[0].intval ) {
				case S_WORD:
					yyval.intval = 2;
					break;

				case S_DWORD:
					yyval.intval = 4;
					break;

				 default:
					error(ERR_NONFATAL, INVSIZERR);
					YYERROR;
			};
		;
    break;}
case 89:
{ instr.eops= NULL; ;
    break;}
case 90:
{ *eoptail= NULL; ;
    break;}
case 91:
{
			if ( !(instr.eops= ProcessExtop(yyvsp[-1].intval, yyvsp[0].result)) ) {
				YYERROR;
			};

			eoptail= &(instr.eops->next);
		;
    break;}
case 92:
{
			if ( !(*eoptail= ProcessExtop(yyvsp[-3].intval, yyvsp[0].result)) ) {
				YYERROR;
			};

			eoptail= &(*eoptail)->next;
		;
    break;}
case 93:
{ yyval.result = yyvsp[0].result; ;
    break;}
case 94:
{ yyval.result = ScalarMult(-1, yyvsp[0].result); ;
    break;}
case 95:
{
			SetCritical(-1);

			if ( IsSimple(yyvsp[0].result) != INTEGER ) {
				error(ERR_NONFATAL, INTERR);
				YYERROR;
			};

			yyval.result= Vectorize(INTEGER, 1, ~IntVal(yyvsp[0].result));
			SetCritical(0);
		;
    break;}
case 96:
{ yyval.result = yyvsp[-1].result; ;
    break;}
case 97:
{ yyval.result = AddExprs(yyvsp[-2].result, yyvsp[0].result); ;
    break;}
case 98:
{ yyval.result = AddExprs( yyvsp[-2].result, ScalarMult(-1, yyvsp[0].result) ); ;
    break;}
case 99:
{
			SetCritical(-1);
			if ( (anInt = IsSimple(yyvsp[-2].result)) == -1) {
				error(ERR_NONFATAL, EXPERR);
				YYERROR;
			};

			if ( anInt != IsSimple(yyvsp[0].result) ) {
				error(ERR_NONFATAL, TYPERR);
				YYERROR;
			};

			if ( anInt == INTEGER ) {
				if ( !(anInt = IntVal(yyvsp[0].result)) ) {
					error(ERR_NONFATAL, DIVERR);
					YYERROR;
				};

				anInt = IntVal(yyvsp[-2].result) / anInt;
				yyval.result = Vectorize(INTEGER, 1, anInt);
			} else {
				error(ERR_NONFATAL, OPRERR);
				YYERROR;
			};
			SetCritical(0);
		;
    break;}
case 100:
{
			SetCritical(-1);
			if ( (anInt = IsSimple(yyvsp[-2].result)) == -1) {
				error(ERR_NONFATAL, EXPERR);
				YYERROR;
			};

			if ( anInt != IsSimple(yyvsp[0].result) ) {
				error(ERR_NONFATAL, TYPERR);
				YYERROR;
			};

			if ( anInt == INTEGER ) {
				if ( !(anInt = IntVal(yyvsp[0].result)) ) {
					error(ERR_NONFATAL, DIVERR);
					YYERROR;
				};

				anInt = IntVal(yyvsp[-2].result) % anInt;
				yyval.result = Vectorize(INTEGER, 1, anInt);
			} else {
				error(ERR_NONFATAL, OPRERR);
				YYERROR;
			};

			SetCritical(0);
		;
    break;}
case 101:
{
			switch ( IsSimple(yyvsp[-2].result) ) {
				case INTEGER:
					switch ( IsSimple(yyvsp[0].result) ) {
						case INTEGER:
					        yyval.result = Vectorize(INTEGER, 1,
						            IntVal(yyvsp[-2].result) * IntVal(yyvsp[0].result) );
					        break;

						case FLOAT:
							yyval.result = Vectorize(FLOAT, 1,
								(float)(IntVal(yyvsp[-2].result) * FloatVal(yyvsp[0].result)) );
							break;

						case -1:
							yyval.result = ScalarMult(IntVal(yyvsp[-2].result), yyvsp[0].result);
							break;

						default:
							error(ERR_NONFATAL, TYPERR);
				            YYERROR;
					};
					break;

				case FLOAT:
					switch ( IsSimple(yyvsp[0].result) ) {
						case INTEGER:
					        yyval.result = Vectorize(FLOAT, 1,
						            (float)(FloatVal(yyvsp[-2].result) * IntVal(yyvsp[0].result)) );
					        break;

						case FLOAT:
							yyval.result = Vectorize(FLOAT, 1,
								FloatVal(yyvsp[-2].result) * FloatVal(yyvsp[0].result) );
							break;

						default:
							error(ERR_NONFATAL, TYPERR);
				            YYERROR;
					};
					break;

				case -1:
					if ( IsSimple(yyvsp[0].result) == INTEGER ) {
						yyval.result = ScalarMult(IntVal(yyvsp[0].result), yyvsp[-2].result);
					} else {
						error(ERR_NONFATAL, INTERR);
						YYERROR;
					}
					break;

				default:
					error(ERR_NONFATAL, OPRERR);
					YYERROR;
			};
		;
    break;}
case 102:
{
			SetCritical(-1);
			if ( (anInt = IsSimple(yyvsp[-2].result)) == -1) {
				error(ERR_NONFATAL, EXPERR);
				YYERROR;
			};

			if ( anInt != -1 && anInt == IsSimple(yyvsp[0].result) ) {
				error(ERR_NONFATAL, TYPERR);
				YYERROR;
			};

			switch ( anInt ) {
				case INTEGER:
					if ( !(anInt = IntVal(yyvsp[0].result)) ) {
						error(ERR_NONFATAL, DIVERR);
						YYERROR;
					};

					anInt = IntVal(yyvsp[-2].result) / anInt;
					yyval.result = Vectorize(INTEGER, 1, anInt);
					break;

				case FLOAT:
					if ( !(aFloat = FloatVal(yyvsp[0].result)) ) {
						error(ERR_NONFATAL, DIVERR);
						YYERROR;
					};

					aFloat = FloatVal(yyvsp[-2].result) / aFloat;
					yyval.result = Vectorize(FLOAT, 1, aFloat);
					break;

				default:
					error(ERR_NONFATAL, OPRERR);
					YYERROR;
			};
			SetCritical(0);
		;
    break;}
case 103:
{
			SetCritical(-1);
			if ( (anInt = IsSimple(yyvsp[-2].result)) == -1) {
				error(ERR_NONFATAL, EXPERR);
				YYERROR;
			};

			if ( anInt != IsSimple(yyvsp[0].result) ) {
				error(ERR_NONFATAL, TYPERR);
				YYERROR;
			};

			if ( anInt != INTEGER ) {
				error(ERR_NONFATAL, OPRERR);
				YYERROR;
			};

			anInt= IntVal(yyvsp[-2].result) >> IntVal(yyvsp[0].result);
		    yyval.result = Vectorize(INTEGER, 1,  anInt);
			SetCritical(0);
		;
    break;}
case 104:
{
			SetCritical(-1);
			if ( (anInt = IsSimple(yyvsp[-2].result)) == -1) {
				error(ERR_NONFATAL, EXPERR);
				YYERROR;
			};

			if ( anInt != IsSimple(yyvsp[0].result) ) {
				error(ERR_NONFATAL, TYPERR);
				YYERROR;
			};

			if ( anInt != INTEGER ) {
				error(ERR_NONFATAL, OPRERR);
				YYERROR;
			};

			anInt= IntVal(yyvsp[-2].result) << IntVal(yyvsp[0].result);
		    yyval.result = Vectorize(INTEGER, 1,  anInt);
			SetCritical(0);
		;
    break;}
case 105:
{
			SetCritical(-1);
			if ( (anInt = IsSimple(yyvsp[-2].result)) == -1) {
				error(ERR_NONFATAL, EXPERR);
				YYERROR;
			};

			if ( anInt != IsSimple(yyvsp[0].result) ) {
				error(ERR_NONFATAL, TYPERR);
				YYERROR;
			};

			if ( anInt != INTEGER ) {
				error(ERR_NONFATAL, OPRERR);
				YYERROR;
			};

			anInt= IntVal(yyvsp[-2].result) & IntVal(yyvsp[0].result);
		    yyval.result = Vectorize(INTEGER, 1,  anInt);
			SetCritical(0);
		;
    break;}
case 106:
{
			SetCritical(-1);
			if ( (anInt = IsSimple(yyvsp[-2].result)) == -1) {
				error(ERR_NONFATAL, EXPERR);
				YYERROR;
			};

			if ( anInt != IsSimple(yyvsp[0].result) ) {
				error(ERR_NONFATAL, TYPERR);
				YYERROR;
			};

			if ( anInt != INTEGER ) {
				error(ERR_NONFATAL, OPRERR);
				YYERROR;
			};

			anInt= IntVal(yyvsp[-2].result) | IntVal(yyvsp[0].result);
		    yyval.result = Vectorize(INTEGER, 1,  anInt);
			SetCritical(0);
		;
    break;}
case 107:
{
			SetCritical(-1);
			if ( (anInt = IsSimple(yyvsp[-2].result)) == -1) {
				error(ERR_NONFATAL, EXPERR);
				YYERROR;
			};

			if ( anInt != IsSimple(yyvsp[0].result) ) {
				error(ERR_NONFATAL, TYPERR);
				YYERROR;
			};

			if ( anInt != INTEGER ) {
				error(ERR_NONFATAL, OPRERR);
				YYERROR;
			};

			anInt= IntVal(yyvsp[-2].result) ^ IntVal(yyvsp[0].result);
		    yyval.result = Vectorize(INTEGER, 1,  anInt);
			SetCritical(0);
		;
    break;}
case 108:
{
			if ( IDType(yyvsp[0].identifier) == LABEL ) {
			    if ( IDFlag(yyvsp[0].identifier) == LOCAL ) {
				    /* Reference to a local procedure variable */
				    yyval.result = Vectorize((CodeBits == 16 ? R_BP : R_EBP), 0);
					Vectorize(INTEGER, 1, yyvsp[0].identifier->Value);
				} else if ( IDFlag(yyvsp[0].identifier) == GLBLBL &&
							yyvsp[0].identifier->segment == UNDEF_SEG ) {
					/* Global symbol is still undefined, return
					   a forward reference */
					yyval.result = Vectorize(SYMREF, 1, yyvsp[0].identifier);
				} else {
					/* Reference to a defined symbol. */
					yyval.result= Vectorize(SEGMENT, 0, yyvsp[0].identifier->segment);
					Vectorize(INTEGER, 1, yyvsp[0].identifier->offset);
				};
			} else if ( yyvsp[0].identifier->Type == NO_TYPE ) {
				/* Forward reference */
				if ( IsCritical() ) {
					/* If flagCritical is set forward references
					   are not allowed */
					error(ERR_NONFATAL, UNDERR, yyvsp[0].identifier->Name);
					FreeSymbol(yyvsp[0].identifier);
					YYERROR;
				};

				yyval.result = Vectorize(SYMREF, 1, yyvsp[0].identifier);
			} else {
			/* We should never reach this, if so panic. */
				error(ERR_PANIC, GENERR, "parser error 1.");
			};
		;
    break;}
case 109:
{ yyval.result = Vectorize(yyvsp[0].intval, 1); ;
    break;}
case 110:
{ yyval.result = Vectorize(INTEGER, 1, yyvsp[0].intval); ;
    break;}
case 111:
{ yyval.result = Vectorize(FLOAT, 1, yyvsp[0].floatval); ;
    break;}
case 112:
{ yyval.result = Vectorize(STR, 1, yyvsp[0].strval, TokenInfo); ;
    break;}
case 113:
{ yyval.result = Vectorize(CHAR, 1, yyvsp[0].chrval); ;
    break;}
case 114:
{ yyval.result = Vectorize(INTEGER, 1, Offset + LocalOffset); ;
    break;}
case 115:
{ yyval.result = Vectorize(INTEGER, 1, Offset); ;
    break;}
case 116:
{ yyval.intval= yyvsp[0].intval; ;
    break;}
case 117:
{ yyval.intval = (yyvsp[-5].intval && yyvsp[-1].intval); ;
    break;}
case 118:
{ yyval.intval = (yyvsp[-5].intval || yyvsp[-1].intval ); ;
    break;}
case 119:
{ yyval.intval = !yyvsp[-1].intval; ;
    break;}
case 120:
{
			if ( yyvsp[-1].identifier->Type == NO_TYPE ) {
				yyval.intval= FALSE;
				FreeSymbol(yyvsp[-1].identifier);
			} else {
				yyval.intval= TRUE;
			}
		;
    break;}
case 121:
{
			SetCritical(-1);

			if ( (anInt = IsSimple(yyvsp[-2].result)) == -1 ) {
				error(ERR_NONFATAL, EXPERR);
				YYERROR;
			} else if ( anInt != IsSimple(yyvsp[0].result) ) {
				error(ERR_NONFATAL, TYPERR);
				YYERROR;
			};

			switch ( anInt ) {
				case INTEGER:
				case CHAR:
					anInt= (IntVal(yyvsp[-2].result) == IntVal(yyvsp[0].result));
					break;

				case FLOAT:
					anInt= (FloatVal(yyvsp[-2].result) == FloatVal(yyvsp[0].result));
					break;

				case STR:
					anInt= strcmp(StrVal(yyvsp[-2].result), StrVal(yyvsp[0].result));
			};

			/* if $2 is zero we are checking for equality */
			yyval.intval= ( yyvsp[-1].intval ? anInt : !anInt);
			SetCritical(0);
		;
    break;}
case 122:
{
			SetCritical(-1);

			if ( (anInt = IsSimple(yyvsp[-2].result)) == -1 ) {
				error(ERR_NONFATAL, EXPERR);
				YYERROR;
			} else if ( anInt != IsSimple(yyvsp[0].result) ) {
				error(ERR_NONFATAL, TYPERR);
				YYERROR;
			};

			/* First check for equality. */
			switch ( anInt ) {
				case INTEGER:
				case CHAR:
					yyval.intval= (IntVal(yyvsp[-2].result) == IntVal(yyvsp[0].result));
					break;

				case FLOAT:
					yyval.intval= (FloatVal(yyvsp[-2].result) == FloatVal(yyvsp[0].result));
					break;

				case STR:
					yyval.intval= (strcmp(StrVal(yyvsp[-2].result), StrVal(yyvsp[0].result)) == 0);
			};

			if ( !yyval.intval || ( yyvsp[-1].intval != 2 && yyvsp[-1].intval != 4 ) ) {
			/* If not equal or strong comparation. */
				switch ( anInt ) {
					case INTEGER:
					case CHAR:
						anInt= (IntVal(yyvsp[-2].result) < IntVal(yyvsp[0].result));
						break;

					case FLOAT:
						anInt= (FloatVal(yyvsp[-2].result) < FloatVal(yyvsp[0].result));
						break;

					case STR:
						anInt= (strcmp(StrVal(yyvsp[-2].result), StrVal(yyvsp[0].result)) < 0);
				};

				yyval.intval= ( yyvsp[-1].intval == 1 || yyvsp[-1].intval == 3 ? anInt : !anInt );
			};

			SetCritical(0);
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */


  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}


/* -------- Local Functions ------------------------------------------- */

/*
	Function......: AssembleProcProlog
	Description...: Generates code for a subroutine prolog.
					Returns the size of the generated code.
	Parameters....:
					Proc		Pointer to the procedure info struct.

					The struct defines the following fields:

					Id			pointer the the symbol of the
								procedure
					SavedRegs	Array containing the codes of registers
								used by the procedure, they must be saved
								on the stack.
					RegCount	Number of rregister to be saved.
					LocalSize	Size of local variables.
					ParamSize	Size of local parameters. */
static long AssembleProcProlog(struct ProcInfo *Proc)
{
	INSN	dummy;
	register int i;
	register long retval= 0;

	/* Push BP/EBP register if there are local variable or parameter
	   and intialize the BP/EBP register with the value in SP/ESP */
	if ( Proc->LocalSize || Proc->ParamSize ) {
	    bzero(&dummy, sizeof(INSN));
	    dummy.times	  = 1;
	    dummy.opcode  = I_PUSH;
	    dummy.operands= 1;

		i = ( CodeBits == 16 ? R_BP : R_EBP);
		dummy.oprs[0].type	 = REGISTER;
	    dummy.oprs[0].type	 |= reg_flags[i];
		dummy.oprs[0].basereg = i;

		retval += assemble(Segment, Offset + retval, CodeBits, &dummy);

		bzero(&dummy, sizeof(INSN));
		dummy.times	  = 1;
		dummy.opcode  = I_MOV;
		dummy.operands= 2;

		dummy.oprs[0].type	 = REGISTER;
	    dummy.oprs[0].type	 |= reg_flags[i];
		dummy.oprs[0].basereg = i;

		i= ( CodeBits == 16 ? R_SP : R_ESP);
		dummy.oprs[1].type	 = REGISTER;
	    dummy.oprs[1].type	 |= reg_flags[i];
		dummy.oprs[1].basereg = i;

		retval += assemble(Segment, Offset + retval, CodeBits, &dummy);
	};

	/* Reserve space for locals if any */
	if ( Proc->LocalSize ) {
		bzero(&dummy, sizeof(INSN));
		dummy.times	  = 1;
		dummy.opcode  = I_SUB;
		dummy.operands= 2;

		i= ( CodeBits == 16 ? R_SP : R_ESP);
		dummy.oprs[0].type	 = REGISTER;
	    dummy.oprs[0].type	 |= reg_flags[i];
		dummy.oprs[0].basereg = i;

		dummy.oprs[1].type	  = IMMEDIATE;
		dummy.oprs[1].segment = NO_SEG;
		dummy.oprs[1].wrt	  = NO_SEG;
		dummy.oprs[1].offset  = Proc->LocalSize;

		retval += assemble(Segment, Offset + retval, CodeBits, &dummy);
	};

	/* Push into the stack the registers to be saved. */
	for (i= 0; i < Proc->RegCount; i++) {
		bzero(&dummy, sizeof(INSN));
	    dummy.times	  = 1;

		if ( Proc->RegList[i] < REG_ENUM_LIMIT ) {
			dummy.opcode  = I_PUSH;
	        dummy.operands= 1;
		    dummy.oprs[0].type	 = REGISTER;
	        dummy.oprs[0].type	 |= reg_flags[Proc->RegList[i]];
		    dummy.oprs[0].basereg = Proc->RegList[i];
		} else {
			dummy.opcode  = ( Proc->RegList[i] == REG_ENUM_LIMIT ?
				I_PUSHAD : I_PUSHAW );
			dummy.operands= 0;
		}

		retval += assemble(Segment, Offset + retval, CodeBits, &dummy);
	};

	return retval;
}


/*
	Function......: AssembleProcEpilog
	Description...: Generates code for a subroutine epilog.
					Returns the size of the generated code.
	Parameters....:
					Proc			Pointer to the procedure info
									structure. */
static long AssembleProcEpilog(struct ProcInfo *Proc)
{
	INSN	dummy;
	register int i;
	register long retval= 0;

	/* No defined procedure, we have no code to assemble */
	if ( !Proc || !Proc->Id ) return 0;

	/* Pop out of the stack the saved registers. */

	for (i= Proc->RegCount - 1; i >= 0; i--) {
		bzero(&dummy, sizeof(INSN));
	    dummy.times	  = 1;

		if ( Proc->RegList[i] < REG_ENUM_LIMIT ) {
			dummy.opcode  = I_POP;
	        dummy.operands= 1;
		    dummy.oprs[0].type	 = REGISTER;
	        dummy.oprs[0].type	 |= reg_flags[Proc->RegList[i]];
		    dummy.oprs[0].basereg = Proc->RegList[i];
		} else {
			dummy.opcode  = ( Proc->RegList[i] == REG_ENUM_LIMIT ?
				I_POPAD : I_POPAW );
			dummy.operands= 0;
		}

		retval += assemble(Segment, Offset + retval, CodeBits, &dummy);
	};

	/* Pop the BP register or assemble the 'leave' instruction. */
	if ( Proc->LocalSize || Proc->ParamSize ) {
	    bzero(&dummy, sizeof(INSN));
		if ( CodeBits == 16 ) {

			if ( Proc->LocalSize ) {
				/* mov sp, bp */
		        dummy.times	  = 1;
		        dummy.opcode  = I_MOV;
		        dummy.operands= 2;

			    dummy.oprs[0].type	 = REGISTER;
		        dummy.oprs[0].type	 |= reg_flags[R_SP];
			    dummy.oprs[0].basereg = R_SP;

			    dummy.oprs[1].type	 = REGISTER;
		        dummy.oprs[1].type	 |= reg_flags[R_BP];
			    dummy.oprs[1].basereg = R_BP;

			    retval += assemble(Segment, Offset + retval, CodeBits,
					&dummy);
			};

			/* pop bp */
	        bzero(&dummy, sizeof(INSN));
	        dummy.times	  = 1;
	        dummy.opcode  = I_POP;
	        dummy.operands= 1;

		    dummy.oprs[0].type	 = REGISTER;
	        dummy.oprs[0].type	 |= reg_flags[R_BP];
		    dummy.oprs[0].basereg = R_BP;
		} else {
	        dummy.times	  = 1;
	        dummy.opcode  = I_LEAVE;
		}

		retval += assemble(Segment, Offset + retval, CodeBits, &dummy);
	};

	return retval;
}


/*
	Function......: IncludeBinary
	Description...: Include a binary file.
					Retunrs the number of bytes successfully included
					into the assembled code.
	Parameters....:
					Filename		Name of the binary file to include
					TotalSize		Total bytes to be included
					Skip			Byte to skip in the source binary
									file. */
static long IncludeBinary(char *Filename, long TotalSize, long Skip)
{
	register long Count= 0;
	register long BytesRead, Bytes2Read;
	FILE *Source;
	char Buffer[1024];

	/* Return if there are no bytes to insert */
	if ( !TotalSize ) return 0;

	/* Open source file */
	LIB_setflags(ERR_NONFATAL);
	Source= LIB_fopen(Filename, M_RDBIN);
	LIB_setflags( -1 ); // Restores the default error reporting flags

	if ( !Source ) return 0;

	/* Assing a value to TotalSize */
	if ( TotalSize == -1 ) {
		fseek(Source, 0L, SEEK_END);
		TotalSize= ftell(Source);
	};

	/* Skip the requested number of bytes */
	fseek(Source, Skip, SEEK_SET);

	do {
		/* Calculates the number of bytes to read in. */
		Bytes2Read= TotalSize - Count;
		if ( Bytes2Read > sizeof(Buffer) ) Bytes2Read= sizeof(Buffer);

		/* Read a chunk of bytes from source file ... */
		BytesRead= fread(Buffer, 1, Bytes2Read, Source);
		/* ... and lay them down on the assembled segment */
		Output(Segment, Offset + Count, Buffer, OUT_RAWDATA + BytesRead,
			NO_SEG, NO_SEG);

		Count += BytesRead;
	} while ( BytesRead == Bytes2Read && Count < TotalSize );

	fclose(Source);

	/* Pad if we haven't fullfilled the TotalSize request. */
	if ( Count < TotalSize ) {
		pad(Segment, Offset + Count, 0, TotalSize - Count);
	};

	return TotalSize;
}


/*
	Function......: DefineLabel
	Description...: Performs all the operation necessary to a label
					definition:
						- Initializes the fields of the struct.
						- Defines the symbol in the output format.
						- Performs the backpatch of the symbol references.
					Returns 0 if successful, -1 otherwise.
					On error calls the global error report function.
	Parameters....:
					Sym     pointer to the SYMBOL struct to be defined. */
static int DefineLabel(SYMBOL *Sym)
{
	int isLocalLabel = !LIB_strnicmp("@@", Sym->Name, 2);

	/* Fill in the SYMBOL fields */
	Sym->Value	= Offset;
	Sym->segment= Segment;
	Sym->offset	= Offset;

	/* Declaration of a local label */
	if (  isLocalLabel ) {
		if ( !CurrProc.Id ) {
		/* Link the symbol to the current section */
		    LinkSymbol(SecId, Sym);
		} else {
		/* Link the local symbol to the closest
		   procedure declaration */
			LinkSymbol(CurrProc.Id, Sym);
		};

	};

	/* Definition of the symbol in the output format */
	if ( Sym->Type == NO_TYPE ) {
	/* Definition of a symbol local to the module */
		Sym->Type = LABEL;
		Symdef(Sym, 0);
	} else if ( IDFlag(Sym) == GLBLBL && !isLocalLabel ) {
	/* Definition of a global symbol */
		Symdef(Sym, 1);
	} else {
		error(ERR_NONFATAL, LBLERR, Sym->Name);
		return -1;
	};

	/* Backpatch the symbol! */
	BPatch(Sym);
	return 0;
}


/*
	Function......: CalcMemRef
	Description...: Calculates the memory reference specified by its
					segment and offset part, converting it to a valid
					operand.
					Returns a pointer to a static storage area, overwritten
					on each call, containing the operand if successfull,
					NULL otherwise.
	Parameters....:
					Seg			pointer to the segment part expression.
					Offs		pointer to the offset part expression. */
static OPERAND *CalcMemRef(register EXPR_RESULT *Seg,
	register EXPR_RESULT *Offs)
{
	static OPERAND anOp;
	int b, i, s;	   /* basereg, indexreg, scale */
	long o;			   /* offset */

	/* Collects forward references if any */
	SymRefs(Offs, OprsCount);

	bzero(&anOp, sizeof(OPERAND));

	if ( Seg ) {	/* segment override */
		if ( Seg[1].type != EXPR_END || Seg->int_result != 1 ||
			 REG_SREG & ~reg_flags[Seg->type] ) {
			error(ERR_NONFATAL, SEGERR);
			return NULL;
		} else if (instr.nprefix == 3) {
			error(ERR_NONFATAL, PREFSERR);
			return NULL;
		} else {
			instr.prefixes[instr.nprefix++] = Seg->type;
		};
	}

	b = i = -1;
	o = s = 0;

	if ( Offs->type < REG_ENUM_LIMIT ) {	/* this bit's a register */
		if ( Offs->int_result == 1 ) {
		/* in fact it can be basereg */
			b = Offs->type;
		} else {
		/* no, it has to be indexreg */
			i = Offs->type;
			s = Offs->int_result;
		};
		Offs++;
	}

	if ( Offs->type != EXPR_END && Offs->type < REG_ENUM_LIMIT ) {
	/* it's a second register */

		if ( Offs->int_result != 1 ) {
		/* it has to be indexreg */
			if ( i != -1 ) {	 /* but it can't be */
				error(ERR_NONFATAL, EAERR);
				return NULL;
			} else {
				i = Offs->type;
				s = Offs->int_result;
			};
		} else {
		/* it can be basereg */
			if ( b != -1 ) {
			/* or can it? */
				i = Offs->type;
				s = 1;
			} else {
				b = Offs->type;
			};
		}
		Offs++;
	};

	if ( Offs->type != EXPR_END ) { /* is there an offset? */
		if ( IsSimple(Offs) != INTEGER ) { /* in fact, is there an error? */
			error(ERR_NONFATAL, EAERR);
			return NULL;
		} else {
			anOp.offset_flag= TRUE;
			o = IntVal(Offs);
		}
	}

	anOp.type = MEMORY;

	if ( b == -1 && ( i == -1 || s == 0) ) {
		anOp.offset_flag= TRUE;
		anOp.type |= MEM_OFFS;
	};

	anOp.basereg  = b;
	anOp.indexreg = i;
	anOp.scale	  = s;
	anOp.wrt	  = NO_SEG;
	anOp.offset	  = o;
	anOp.segment  = SegmentVal(Offs);

	EvaluatorReset();
	mref= 0;

	return &anOp;
}


/*
	Function......: ProcessOverride
	Description...: Processes operand size override specifier.
					Returns the appropriate operand type flag if
					successfull, -1 otherwise.
	Parameters....:
					SizeSpec		  Value of the specifier. */
static int ProcessOverride(int SizeSpec)
{
	switch ( SizeSpec ) {
		case S_BYTE:	return BITS8;
		case S_WORD:	return BITS16;
		case S_DWORD:	return BITS32;
		case S_QWORD:	return BITS64;
		case S_TWORD:	return BITS80;
		case S_FAR:		return FAR;
		case S_NEAR:	return NEAR;
		case S_SHORT:	return SHORT;
	};

	error(ERR_NONFATAL, INVSIZERR);
	return -1;
}


/*
	Function......: ProcessOperand
	Description...: Processes an expression converting it in a valid operand
					for an istructions.
					Returns a pointer to static a storage area, overwritten
					on each call, containing the operand if successfull,
					NULL if errors are encountered.
	Parameters....:
					e			pointer to the expression containing the
								operand. */
static OPERAND *ProcessOperand(EXPR_RESULT *e)
{
	static OPERAND anOp;

	if ( mref ) {
	/* If the global flag 'mref' is set the expression is a memory reference
	   so call the appropriate function to resolve it */
		return CalcMemRef(NULL, e);
	}

	bzero(&anOp, sizeof(OPERAND));
	anOp.segment  = NO_SEG;
	anOp.wrt	  = NO_SEG;
	anOp.basereg  = -1;

	switch ( IsSimple(e) ) {
		case INTEGER:
		/* Immediate operand */
			anOp.type	 |= IMMEDIATE;
			anOp.offset	 = IntVal(e);
			anOp.segment = SegmentVal(e);

			if ( !SymRefs(e, OprsCount) &&
				 anOp.offset == 1 && anOp.segment == NO_SEG ) {
			/* The operand is the numeric constant 1 */
				anOp.type |= UNITY;
			}
			break;

		case CHAR:
		/* Immediate char constant with any symbol reference */
			anOp.type	 |= IMMEDIATE;
			anOp.offset	 = ChrVal(e);
			break;

		case FLOAT:
		case STR:
			error(ERR_NONFATAL, INSERR);
			return NULL;

		default:
			if ( e->type >= MAXTYPE || e->int_result != 1 ) {
				error(ERR_NONFATAL, INSERR);
				return NULL;
			};

			/* Immediate register */
			anOp.type	&= TO;
			anOp.type	|= REGISTER;
			anOp.type	|= reg_flags[e->type];
			anOp.basereg = e->type;

			/* There would not be nothing after the register. */
			e++;
			if ( e->type != EXPR_END ) {
				error(ERR_NONFATAL, INSERR);
				return NULL;
			};
	};

	EvaluatorReset();
	return &anOp;
}


/*
	Function......: ProcessExtop
	Description...: Builds up an operand for a data definition istruction
					starting from the expression that defines the operand.
					Returns the pointer to the constructed operand if
					successfull, NULL otherwise. The function reports errors
					via the global error reporting function.
					NOTE: This function modifies the global variable
						  LocalOffset.
	Parameters....:
					Code		opcode of the data definition istruction.
					e			pointer to the expression to start from. */
static EXTOP *ProcessExtop(int Code, EXPR_RESULT *e)
{
	EXTOP *RetVal;
	int type;
	short int DataSize;
	short int Alignment;

	type= IsSimple(e);

	if ( type == -1 || Code < I_DB || Code > I_DW ) {
		error(ERR_NONFATAL, INSERR);
		EvaluatorReset();
		return NULL;
	};

	/* Build up the return value.
	   Datas are stored in the EXTOP structure only in two format:
		   - EOT_DB_NUMBER	a single number (integer or char)
			 stored in the offset field of the structure.
		   - EOT_DB_STRING	a string of datas (chars or float values)
			 stored in a memory area pointed by the stringval field of
			 the structure whose size is specified by the stringlen field
			 of the same structure.
	   The code of the data definition pseudo instruction tells only which
	   alignment to use for data layout. */
	RetVal= (EXTOP *)LIB_malloc(sizeof(EXTOP));

	switch ( type ) {
		case INTEGER:
			RetVal->type     = EOT_DB_NUMBER;
			RetVal->extop_off= IntVal(e);

			if ( Code == I_DB && RetVal->extop_off >= 0 && RetVal->extop_off <= 255 ) {
				DataSize= 1;
			    RetVal->extop_seg= NO_SEG;
	            RetVal->extop_wrt= NO_SEG;
			} else if ( RetVal->extop_off >= -32768 && RetVal->extop_off <= 32767 ) {
				DataSize= sizeof(short int);
	            RetVal->extop_seg= SegmentVal(e);
	            RetVal->extop_wrt= NO_SEG;
			} else {
				DataSize= sizeof(long);
	            RetVal->extop_seg= SegmentVal(e);
	            RetVal->extop_wrt= NO_SEG;
			};
			break;

		case CHAR:
			RetVal->type     = EOT_DB_NUMBER;
			RetVal->extop_off= ChrVal(e);
	   	    RetVal->extop_seg= NO_SEG;
			RetVal->extop_wrt= NO_SEG;
			DataSize= 1;
			break;

		case FLOAT:
			RetVal->type	    = EOT_DB_STRING;
			RetVal->extop_string= (char *)LIB_malloc(sizeof(float));
			DataSize= sizeof(float);
			/* Yes, this is the power of C ! */
			*((float *)RetVal->extop_string)= FloatVal(e);
			break;

		case STR:
			RetVal->type	     = EOT_DB_STRING;
			RetVal->extop_string = StrVal(e);
			RetVal->extop_length = e->str_leng;
			DataSize= e->str_leng;
	};

	/* Now collect forward references contained in the expression */
	if ( RetVal->type == EOT_DB_NUMBER &&
		 SymRefs(e, -1, RetVal->extop_off, RetVal->extop_seg) ) {
		/* The expression contains forward reference so it can be assembled
		   the returned operand is declared of type DUMMY, it is used only
		   to calculate istruction size and it not actually generate
		   code. */
		RetVal->type = EOT_DUMMY;
	};

	/* Now align datas and modify LocalOffset */
	switch ( Code ) {
		case I_DB:
			Alignment= 1;
			break;

		case I_DW:
			Alignment= 2;
			break;

		case I_DD:
			Alignment= 4;
			break;

		case I_DQ:
			Alignment= 8;
			break;

		case I_DT:
			Alignment= 10;
			break;

		default:
			error(ERR_FATAL, GENERR, "parser error in ProcessExtop().");
			return NULL;
	};

	LocalOffset += - (DataSize % Alignment);

	EvaluatorReset();
	return RetVal;
}


/*
	Function......: InstrCleanup
	Description...: Clears all the fields of the instr struct, resets some
					global variable, preparing the parser for the next
					instruction.
	Parameters....: None. */
static void InstrCleanup()
{
	register EXTOP *Crsr = instr.eops;
	register EXTOP *Next;

	/* Clear extops if any */
	while ( Crsr ) {
		Next = Crsr->next;
		LIB_free(Crsr);
		Crsr = Next;
	};

	bzero(&instr, sizeof(INSN));
	instr.times		=  1;
	instr.opcode	= -1;
	instr.condition = -1;

	LocalOffset = 0;
	mref		= 0;
	OprsCount	= 0;
	PatchPtr	= NULL;
	EvaluatorReset();
}


/*
	Function......: SymRefs
	Description...: Collects all forward references within an expression.
					Returns the number of forward references encountered.
					The function also adds the patch information to the
					list of references associated with a symbol.
	Parameters....:
					e				pointer to the expression to be analyzed
					PatchType		type of the patch informations to add
					...				additional informations. */
static int SymRefs(register EXPR_RESULT *e, short PatchType, ...)
{
	register int RetVal = 0;
	va_list	 arg_ptr;

	va_start(arg_ptr, PatchType);

	while ( e->type != EXPR_END ) {

		if ( e->type == SYMREF ) {
			RetVal++;
			if ( PatchPtr == NULL ) {
			/* Allocate the patch which the reference will referes to */
				PatchPtr= (PATCH *)LIB_malloc(sizeof(PATCH));
				PatchPtr->Seg	 = Segment;

				if ( PatchType < 0 || PatchType >= 3 ) {
				    PatchPtr->Offset    = LocalOffset + Offset;
					PatchPtr->patch_off = va_arg(arg_ptr, long);
					PatchPtr->patch_seg = va_arg(arg_ptr, long);
				} else {
					PatchPtr->Offset = Offset;
				};

				PatchPtr->Bits	 = CodeBits;
			};

			/* Add the reference to the backpatchlist of the symbol */
			AddPatchRef(e->SymId, PatchPtr, PatchType, e->SymOccur);
		};

		e++;
	};

	va_end(arg_ptr);
	return RetVal;
}

static int yyerror(char *s)
{
	error(ERR_NONFATAL, PARSE_ERR, yytext);
	return -1;
}

/* -------- Public Functions ------------------------------------------ */




/*
	Function......: ParserInit
	Description...: Initializes the parser setting global variables and
					opening the input file.
					Parses the input file and generates the output calling
					the _cleanup() dirver interface function.
					This function is the main entry point of the whole
					module.
					Returns 0 if the parser has been correctly initialized
					(i.e. the file was correctly opened), -1 on errors.
					The functions calls the global error reporting function
					if errors are detected.
					NOTE: Each parameter is a pointer to an area of static
						  storage of size FILENAME_MAX.
	Parameters....:
					InName			Name of the file to be parsed.
					OutName			Name of the file to be generated. */
int Compile(char *InName, char *OutName)
{
	int undefined;

	instr.eops = NULL;
	InstrCleanup();
	yylineno	= 1;
	CodeBits	= 16;

	bzero(&CurrProc, sizeof(struct ProcInfo));
	LIB_addExtension(InName, InName, ".ASM");

	/* Setup the input buffer */
	if ( SwitchToFile(InName) ) return -1;

	/* Initialize the output driver */
	if ( DriverInit(OutName) ) return -1;

	/* Define the symbol for the text section (required) and
	   switch to this section. */
	SecId = LookUp("TEXT", IdCase);
	SecId->Type		= (LABEL | SECLBL);
	SecId->Value	= -1;
	SecId->segment	= Segment = Section(NULL);
	SecId->offset	= Offset  = 0;

	/* Call the parsing function */
	if ( yyparse() || Errors ) {
		error(ERR_FATAL | ERR_NOFILE, EXITERR, Errors);
		return -1;
	};

	if ( (undefined= UndefSymNum()) ) {
		error(ERR_FATAL | ERR_NOFILE, UNDEFSYMSERR, undefined);
		return -1;
	};

	Cleanup();

	return 0;
}

/* --------- End of File --------------------------------------- */
