/*
		JAS v1.00							  (c) 1996 NikSoft International
		--------------------------------------------------------------------
		EVAL.H

		Evaluator function's prototypes.
*/

#ifndef __EVAL_H

#define __EVAL_H
#include "ptypes.h"

extern void			EvaluatorReset();
extern void			SetCritical(short);
extern short		IsCritical();
extern EXPR_RESULT	*Vectorize(int, int, ...);
extern EXPR_RESULT	*AddExprs(register EXPR_RESULT *, register EXPR_RESULT *);
extern EXPR_RESULT	*ScalarMult(long, EXPR_RESULT *);

extern int		IsSimple(register EXPR_RESULT *);
extern float	FloatVal(register EXPR_RESULT *);
extern long		SegmentVal(register EXPR_RESULT *);
extern int		IntVal(register EXPR_RESULT *);
extern char		ChrVal(register EXPR_RESULT *);
extern char		*StrVal(register EXPR_RESULT *);

#endif

/* -------- End Of File ----------------------------------------------- */
